/*  Find Offset - Permet de trouver l'adresse d'un fichier dans un autre
    Copyright (C) 2010-2011 Tartine
    
    email: moidekonoha@free.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <stdio.h>
#include <stdlib.h>

int main(int argc, char* argv[])
{
    FILE* fichier_a_chercher = NULL;
    FILE* fichier_ou_chercher = NULL;
    int i = 0;
    int beg_offset = 0;
    int search = 0;

    fichier_a_chercher = fopen(argv[2], "rb"); //argument 2 de la commande
    fichier_ou_chercher = fopen(argv[3], "rb"); // argument 3 de la commande

    beg_offset = strtol(argv[1], NULL, 16);
    /**On convertit l'argument 1 de la commande en nombre hexa puisqu'il s'agit
    d'un adresse à partir de laquelle on commence à chercher**/

    fread(&search, 4, 1, fichier_a_chercher);
    //On lit les 4 premiers octets du fichier qu'on veut trouver

    fseek(fichier_ou_chercher, beg_offset, SEEK_SET);
    //On se déplace dans le fichier où on cherche à l'adresse demandée

    while(i != search)
    //Tant que ce qu'on lit est différent des 4 octets du fichier
    {
        beg_offset+=4;//On augmente le compter de 4 puisqu'on lit de 4 en 4
        i = 0;
        /**On clear le buffer en le mettant à 0 sinon i additionne les valeurs
        que lui donne fread à chaque tour de boucle**/
        fread(&i, 4, 1, fichier_ou_chercher);
        //On lit 4 octets
    }

    printf("%x\n", beg_offset-4);
    //Comme on a démarrer à +4 la vraie adresse est à -4


    return 0;
}
